package se.softstuff.nb.guicomponentmarker.api;

import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author stefan
 */
public class MarkerUtilities {
    
    private MarkerUtilities(){}
    
    /**
     * Finds the binary for a class 
     * @param clazz to find for
     * @return the binary, empty or set but not null
     */
    public static String findBinaryFor(Class clazz){
        String binary = ""; // NOI18N
        try {
            if (clazz==null || clazz.getResource("") != null) { // NOI18N
                binary = clazz.getResource("").getPath(); // NOI18N
                binary = binary.substring(0, binary.indexOf("!")); // NOI18N
                binary = binary.substring(binary.lastIndexOf("/") + 1); // NOI18N
            }
        } catch (Exception ignore) {
            Logger.getLogger(MarkerUtilities.class.getName()).log(Level.FINE, "Cant find binary for "+clazz, ignore);  // NOI18N
        }
        return binary;
    }
}
